package espresso;

/**
 *  A generic routine to perform an operation for each output function
 *
 *  func() is called with a PLA for each output function (with the output
 *  part effectively removed).
 *  func1() is called after reforming the equivalent output function
 *
 *  Each function returns TRUE if process is to continue
 */
interface Iout_func {
	/**
	 * is called after reforming the equivalent output function
	 *
	 * @param PLA
	 * @param i an index
	 * @return true if process is to continue
	 */
	boolean fout(JpPLA PLA, int i);
}
