package espresso;

import java.util.Comparator;

/**
 * Java: setc.c, d1_order
 */
final class Jdistance_order implements Comparator<Jset> {
	/** d1_order -- comparison for distance-1 merge routine */
	// static int d1_order(final Jset a1, final Jset b1) {
	static final int d1_order(final Jset a, final Jset b) {
		final int[] c1 = Jglobals.cube.temp[0];
		int i = Jespresso.LOOP( a );
		do {
			final long x1 = ((long)(a.base[ a.offset + i ] | c1[ i ]) & 0xffffffffL);
			final long x2 = ((long)(b.base[ b.offset + i ] | c1[ i ]) & 0xffffffffL);
			if( x1 > x2 ) {
				return -1;
			} else if( x1 < x2 ) {
				return 1;
			}
		} while( --i > 0 );
		return 0;
	}

	/** d1_order -- comparison for distance-1 merge routine */
	@Override
	public final int compare(final Jset a, final Jset b) {
		final int[] c1 = Jglobals.cube.temp[0];
		int i = Jespresso.LOOP( a );
		do {
			final long x1 = ((long)(a.base[ a.offset + i ] | c1[ i ]) & 0xffffffffL);
			final long x2 = ((long)(b.base[ b.offset + i ] | c1[ i ]) & 0xffffffffL);
			if( x1 > x2 ) {
				return -1;
			} else if( x1 < x2 ) {
				return 1;
			}
		} while( --i > 0 );
		return 0;
	}
}
