package espresso;
final class Jdominate {

	static int sm_row_dominance(final Jsm_matrix A) {
		final int rowcnt = A.nrows;

		/* Check each row against all other rows */
		for( Jsm_row prow = A.first_row; prow != null; prow = prow.next_row ) {

			/* Among all columns with a 1 in this row, choose smallest */
			Jsm_col least_col = Jsparse.sm_get_col( A, prow.first_col.col_num );
			for( Jsm_element p = prow.first_col.next_col; p != null; p = p.next_col ) {
				final Jsm_col pcol = Jsparse.sm_get_col( A, p.col_num );
				if( pcol.length < least_col.length ) {
					least_col = pcol;
				}
			}

			/* Only check for containment against rows in this column */
			for( Jsm_element pnext, p = least_col.first_row; p != null; p = pnext ) {
				pnext = p.next_row;

				final Jsm_row prow1 = Jsparse.sm_get_row( A, p.row_num );
				if( (prow1.length > prow.length) ||
						(prow1.length == prow.length &&
						prow1.row_num > prow.row_num) ) {
					if( Jrows.sm_row_contains( prow, prow1 ) ) {
						Jmatrix.sm_delrow( A, prow1.row_num );
					}
				}
			}
		}

		return rowcnt - A.nrows;
	}

	static int sm_col_dominance(final Jsm_matrix A, final int[] weight) {
		final int colcnt = A.ncols;

		/* Check each column against all other columns */
		for( Jsm_col next_col, pcol = A.first_col; pcol != null; pcol = next_col ) {
			next_col = pcol.next_col;

			/* Check all rows to find the one with fewest elements */
			Jsm_row least_row = Jsparse.sm_get_row( A, pcol.first_row.row_num );
			for( Jsm_element p = pcol.first_row.next_row; p != null; p = p.next_row ) {
				final Jsm_row prow = Jsparse.sm_get_row( A, p.row_num );
				if( prow.length < least_row.length ) {
					least_row = prow;
				}
			}

			/* Only check for containment against columns in this row */
			for( Jsm_element p = least_row.first_col; p != null; p = p.next_col) {
				final Jsm_col pcol1 = Jsparse.sm_get_col( A, p.col_num );
				if( weight != null && weight[pcol1.col_num] > weight[pcol.col_num] ) {
					continue;
				}
				if( (pcol1.length > pcol.length) ||
						(pcol1.length == pcol.length &&
						pcol1.col_num > pcol.col_num) ) {
					if( Jcols.sm_col_contains( pcol, pcol1 ) ) {
						Jmatrix.sm_delcol( A, pcol.col_num );
						break;
					}
				}
			}
		}

		return colcnt - A.ncols;
	}
}