package espresso;
final class Jequiv {


	@SuppressWarnings("boxing")
	static void find_equiv_outputs(final JpPLA PLA) {
		boolean some_equiv = false;

		Jcvrout.makeup_labels( PLA );

		final Jcube_struct cube = Jglobals.cube;// java
		final Jset_family[] F = new Jset_family[ cube.part_size[ cube.output ] ];
		final Jset_family[] R = new Jset_family[ cube.part_size[ cube.output ] ];

		for( int i = 0; i < cube.part_size[ cube.output ]; i++ ) {
			final int ipart = cube.first_part[ cube.output ] + i;
			R[i] = Jcvrm.cof_output( PLA.R, ipart );
			F[i] = Jcompl.complement( Jcofactor.cube1list( R[ i ] ) );
		}

		for( int i = 0; i < cube.part_size[ cube.output ] - 1; i++ ) {
			for( int j = i + 1; j < cube.part_size[ cube.output ]; j++ ) {
				final int ipart = cube.first_part[ cube.output ] + i;
				final int jpart = cube.first_part[ cube.output ] + j;

				if( check_equiv( F[i], F[j] ) ) {
					System.out.printf("# Outputs %d and %d (%s and %s) are equivalent\n",
							i, j, PLA.label[ ipart ], PLA.label[ jpart ] );
					some_equiv = true;
				} else if( check_equiv( F[ i ], R[ j ] ) ) {
					System.out.printf("# Outputs %d and NOT %d (%s and %s) are equivalent\n",
							i, j, PLA.label[ ipart ], PLA.label[ jpart ] );
					some_equiv = true;
				} else if( check_equiv( R[ i ], F[ j ] ) ) {
					System.out.printf("# Outputs NOT %d and %d (%s and %s) are equivalent\n",
							i, j, PLA.label[ ipart ], PLA.label[ jpart ] );
					some_equiv = true;
				} else if( check_equiv( R[ i ], R[ j ] ) ) {
					System.out.printf("# Outputs NOT %d and NOT %d (%s and %s) are equivalent\n",
							i, j, PLA.label[ ipart ], PLA.label[ jpart ] );
					some_equiv = true;
				}
			}
		}

		if( ! some_equiv ) {
			System.out.printf("# No outputs are equivalent\n");
		}

		// for( int i = 0; i < cube.part_size[cube.output]; i++ ) {
		//	F[i] = null;
		//	R[i] = null;
		// }
		// F = null;
		// R = null;
	}

	static boolean check_equiv(final Jset_family f1, final Jset_family f2) {
		final Jset[] f1list = Jcofactor.cube1list( f1 );
		int[] data = f2.data;// java
		for( int p = 0, last = p + f2.count * f2.wsize; p < last; p += f2.wsize ) {
			if( ! Jirred.cube_is_covered( f1list, data, p ) ) {
				return false;
			}
		}
		// f1list = null;

		final Jset[] f2list = Jcofactor.cube1list( f2 );
		data = f1.data;// java
		for( int p = 0, last = p + f1.count * f1.wsize; p < last; p += f1.wsize ) {
			if( ! Jirred.cube_is_covered( f2list, data, p ) ) {
				return false;
			}
		}
		// f2list = null;

		return true;
	}
}