package espresso;

final class Jgetopt {
/*  File   : getopt.c
    Author : Henry Spencer, University of Toronto
    Updated: 28 April 1984
    Purpose: get option letter from argv.
*/
	/** Global argument pointer. */
	// private int optarg = -1;
	private String optarg_str = null;

	/** Global argv index. */
	private int optind = 0;

	/** Private scan pointer. */
	private int scan = -1;
	private String scan_str = null;

	@SuppressWarnings("boxing")
	final int getopt(final int argc, final String[] argv, final String optstring) {

		// optarg = -1;
		optarg_str = null;

		if( scan < 0 || scan >= scan_str.length() || scan_str.charAt( scan ) == '\0' ) {
			//if( optind == 0 ) {// java: c put a file name as the first argument
			//	optind++;
			//}
			if( optind >= argc ) {
				return -1;
			}
			final String place_str = argv[ optind ];
			if( place_str.charAt( 0 ) != '-' || place_str.length() == 1 || place_str.charAt( 1 ) == '\0' ) {
				return -1;
			}
			optind++;
			if( place_str.charAt( 1 ) == '-' && (place_str.length() == 2 || place_str.charAt( 2 ) == '\0') ) {
				return -1;
			}
			scan_str = place_str;
			scan = 1;
		}

		final char c = scan_str.charAt( scan++ );
		int place = optstring.indexOf( c );
		if( place < 0 || c == ':' ) {
			System.err.printf("%s: unknown option %c\n", argv[0], c );
			return '?';
		}
		if( optstring.charAt( ++place ) == ':' ) {
			if( scan < scan_str.length() && scan_str.charAt( scan ) != '\0' ) {
				optarg_str = scan_str;
				// optarg = scan;
				scan_str = null;
				scan = -1;
			} else {
				optarg_str = argv[ optind ];
				// optarg = 0;
				optind++;
			}
		}
		return c;
	}

	final int getIndex() {
		return optind;
	}

	final String getString() {
		return optarg_str;
	}
}