package espresso;
final class Jgimpel {


	/**
	 *  check for:
	 *
	 *		c1	c2	rest
	 *		--      --      ---
	 *		 1	 1	0 0 0 0		<-- primary row
	 *		 1	 0	S1		<-- secondary row
	 *		 0       1	T1
	 *		 0       1	T2
	 *		 0       1	Tn
	 *		 0       0      R
	 */
	static boolean gimpel_reduce(final Jsm_matrix A, final Jsolution select, final int[] weight, final int lb, final int bound, final int depth, final Jstats_t stats, final Jsolution[] best)
	{
		Jsm_col c1 = A.cols[0], c2 = A.cols[0];// java to fix may not have been not initialized
		int primary_row_num = 0, secondary_row_num = 0;;// java to fix may not have been not initialized

		boolean reduce_it = false;
		for( Jsm_row prow = A.first_row; prow != null; prow = prow.next_row ) {
			if( prow.length == 2 ) {
				c1 = Jsparse.sm_get_col( A, prow.first_col.col_num );
				c2 = Jsparse.sm_get_col( A, prow.last_col.col_num );
				if( c1.length == 2 ) {
					reduce_it = true;
				} else if( c2.length == 2 ) {
					c1 = Jsparse.sm_get_col( A, prow.last_col.col_num );
					c2 = Jsparse.sm_get_col( A, prow.first_col.col_num );
					reduce_it = true;
				}
				if( reduce_it ) {
					primary_row_num = prow.row_num;
					secondary_row_num = c1.first_row.row_num;
					if( secondary_row_num == primary_row_num ) {
						secondary_row_num = c1.last_row.row_num;
					}
					break;
				}
			}
		}

		if( reduce_it ) {
			final int c1_col_num = c1.col_num;
			final int c2_col_num = c2.col_num;
			final Jsm_row save_sec = Jrows.sm_row_dup( Jsparse.sm_get_row( A, secondary_row_num ) );
			Jrows.sm_row_remove( save_sec, c1_col_num );

			for( Jsm_element p = c2.first_row; p != null; p = p.next_row ) {
				if( p.row_num != primary_row_num ) {
					/* merge rows S1 and T */
					for( Jsm_element p1 = save_sec.first_col; p1 != null; p1 = p1.next_col ) {
						Jmatrix.sm_insert( A, p.row_num, p1.col_num );
					}
				}
			}

			Jmatrix.sm_delcol( A, c1_col_num );
			Jmatrix.sm_delcol( A, c2_col_num );
			Jmatrix.sm_delrow( A, primary_row_num );
			Jmatrix.sm_delrow( A, secondary_row_num );

			stats.gimpel_count++;
			stats.gimpel++;
			best[0] = Jmincov.sm_mincov( A, select, weight, lb - 1, bound - 1, depth, stats );
			stats.gimpel--;

			if( best[0] != null ) {
				/* is secondary row covered ? */
				if( Jrows.sm_row_intersects( save_sec, best[0].row ) ) {
					/* yes, actually select c2 */
					Jsolution.solution_add( best[0], weight, c2_col_num );
				} else {
					Jsolution.solution_add( best[0], weight, c1_col_num );
				}
			}

			Jrows.sm_row_free( save_sec );
			return true;
		}// else {
			return false;
		//}
	}
}