package espresso;

/**
 *    Global Variable Declarations
 */
final class Jglobals {
	/** debug parameter */
	static int debug;

	/** -v:  whether to print a lot */
	static boolean verbose_debug;

	/** basic function names */
	static String total_name[];// = new String[ Jespresso.TIME_COUNT ];

	/** time spent in basic fcts */
	static long total_time[];// = new long[ Jespresso.TIME_COUNT ];

	/** # calls to each fct */
	static int total_calls[];// = new int[ Jespresso.TIME_COUNT ];

	/** turned off by -eat option */
	static boolean echo_comments;

	/** always true ?? */
	static boolean echo_unknown_commands;

	/** -nirr command line option */
	static boolean force_irredundant;

	static boolean skip_make_sparse;

	/** -kiss command line option */
	static boolean kiss;

	/** -pos command line option */
	static boolean pos;

	/** -x command line option */
	static boolean print_solution;

	/** -onset command line option */
	static boolean recompute_onset;

	/** -ness command line option */
	static boolean remove_essential;

	/** -fast command line option */
	static boolean single_expand;

	/** -s command line option */
	static boolean summary;

	/** -t command line option */
	static boolean trace;

	/** -nunwrap command line option */
	static boolean unwrap_onset;

	/** -random command line option */
	static boolean use_random_order;

	/** -strong command line option */
	static boolean use_super_gasp;

	/** filename PLA was read from */
	static String filename;

	static Jpla_types_struct pla_types[];/* = {
		new Jpla_types_struct("-f", Jespresso.F_type),
		new Jpla_types_struct("-r", Jespresso.R_type,
		new Jpla_types_struct("-d", Jespresso.D_type),
		new Jpla_types_struct("-fd", Jespresso.FD_type),
		new Jpla_types_struct("-fr", Jespresso.FR_type),
		new Jpla_types_struct("-dr", Jespresso.DR_type),
		new Jpla_types_struct("-fdr", Jespresso.FDR_type),
		new Jpla_types_struct("-fc", Jespresso.F_type | Jespresso.CONSTRAINTS_type),
		new Jpla_types_struct("-rc", Jespresso.R_type | Jespresso.CONSTRAINTS_type),
		new Jpla_types_struct("-dc", Jespresso.D_type | Jespresso.CONSTRAINTS_type),
		new Jpla_types_struct("-fdc", Jespresso.FD_type | Jespresso.CONSTRAINTS_type),
		new Jpla_types_struct("-frc", Jespresso.FR_type | Jespresso.CONSTRAINTS_type),
		new Jpla_types_struct("-drc", Jespresso.DR_type | Jespresso.CONSTRAINTS_type),
		new Jpla_types_struct("-fdrc", Jespresso.FDR_type | Jespresso.CONSTRAINTS_type),
		new Jpla_types_struct("-pleasure", Jespresso.PLEASURE_type),
		new Jpla_types_struct("-eqn", Jespresso.EQNTOTT_type),
		new Jpla_types_struct("-eqntott", Jespresso.EQNTOTT_type),
		new Jpla_types_struct("-kiss", Jespresso.KISS_type),
		new Jpla_types_struct("-cons", Jespresso.CONSTRAINTS_type),
		new Jpla_types_struct("-scons", Jespresso.SYMBOLIC_CONSTRAINTS_type)
	}; */

	static Jcube_struct cube;// = new Jcube_struct();
	static Jcube_struct temp_cube_save;// = new Jcube_struct();
	static Jcdata_struct cdata;// = new Jcdata_struct();
	static Jcdata_struct temp_cdata_save;// = new Jcdata_struct();

	static {
		total_name = new String[ Jespresso.TIME_COUNT ];
		total_time = new long[ Jespresso.TIME_COUNT ];
		total_calls = new int[ Jespresso.TIME_COUNT ];
		pla_types = new Jpla_types_struct[] {
				new Jpla_types_struct("-f", Jespresso.F_type),
				new Jpla_types_struct("-r", Jespresso.R_type),
				new Jpla_types_struct("-d", Jespresso.D_type),
				new Jpla_types_struct("-fd", Jespresso.FD_type),
				new Jpla_types_struct("-fr", Jespresso.FR_type),
				new Jpla_types_struct("-dr", Jespresso.DR_type),
				new Jpla_types_struct("-fdr", Jespresso.FDR_type),
				new Jpla_types_struct("-fc", Jespresso.F_type | Jespresso.CONSTRAINTS_type),
				new Jpla_types_struct("-rc", Jespresso.R_type | Jespresso.CONSTRAINTS_type),
				new Jpla_types_struct("-dc", Jespresso.D_type | Jespresso.CONSTRAINTS_type),
				new Jpla_types_struct("-fdc", Jespresso.FD_type | Jespresso.CONSTRAINTS_type),
				new Jpla_types_struct("-frc", Jespresso.FR_type | Jespresso.CONSTRAINTS_type),
				new Jpla_types_struct("-drc", Jespresso.DR_type | Jespresso.CONSTRAINTS_type),
				new Jpla_types_struct("-fdrc", Jespresso.FDR_type | Jespresso.CONSTRAINTS_type),
				new Jpla_types_struct("-pleasure", Jespresso.PLEASURE_type),
				new Jpla_types_struct("-eqn", Jespresso.EQNTOTT_type),
				new Jpla_types_struct("-eqntott", Jespresso.EQNTOTT_type),
				new Jpla_types_struct("-kiss", Jespresso.KISS_type),
				new Jpla_types_struct("-cons", Jespresso.CONSTRAINTS_type),
				new Jpla_types_struct("-scons", Jespresso.SYMBOLIC_CONSTRAINTS_type)
			};
		cube = new Jcube_struct();
		temp_cube_save = new Jcube_struct();
		cdata = new Jcdata_struct();
		temp_cdata_save = new Jcdata_struct();
	}
}