package espresso;
final class Jhack {

	static void map_dcset(final JpPLA PLA) {
		final Jcube_struct cube = Jglobals.cube;// java

		if( PLA.label == null || PLA.label[0] == null ) {
			return;
		}

		/* try to find a binary variable named "DONT_CARE" */
		int var = -1;
		for( int i = 0, ie = cube.num_binary_vars << 1; i < ie; i++ ) {
			if( PLA.label[i].startsWith("DONT_CARE") ||
				PLA.label[i].startsWith("DONTCARE") ||
				PLA.label[i].startsWith("dont_care") ||
				PLA.label[i].startsWith("dontcare") ) {
				var = i >>> 1;
				break;
			}
		}
		if( var == -1 ) {
			return;
		}

		/* form the cofactor cubes for the don't-care variable */
		final int[] cplus = Jset.set_save( cube.fullset );
		final int[] cminus = Jset.set_save( cube.fullset );
		Jespresso.set_remove( cplus, var << 1 );
		Jespresso.set_remove( cminus, (var << 1) + 1 );

		final Jset_family Tplus[] = new Jset_family[1];// java holder
		final Jset_family Tminus[] = new Jset_family[1];// java holder
		final Jset_family Tplusbar[] = new Jset_family[1];// java holder
		final Jset_family Tminusbar[] = new Jset_family[1];// java holder

		/* form the don't-care set */
		{
			final long t = System.currentTimeMillis();
			Jcompl.simp_comp( Jcofactor.cofactor( Jcofactor.cube1list( PLA.F ), cplus, 0 ), Tplus, Tplusbar );
			if( Jglobals.trace ) {
				Jcvrmisc.print_trace( Tplus[0], "simpcomp+", System.currentTimeMillis() - t );
			}
		}
		{
			final long t = System.currentTimeMillis();
			Jcompl.simp_comp( Jcofactor.cofactor( Jcofactor.cube1list( PLA.F ), cminus, 0 ), Tminus, Tminusbar );
			if( Jglobals.trace ) {
				Jcvrmisc.print_trace( Tminus[0], "simpcomp-", System.currentTimeMillis() - t );
			}
		}
		Jset_family term1, term2, dcset, newf;
		{
			final long t = System.currentTimeMillis();
			term1 = Jsharp.cv_intersect( Tplus[0], Tminusbar[0] );
			if( Jglobals.trace ) {
				Jcvrmisc.print_trace( term1, "term1    ", System.currentTimeMillis() - t );
			}
		}
		{
			final long t = System.currentTimeMillis();
			term2 = Jsharp.cv_intersect( Tminus[0], Tplusbar[0] );
			if( Jglobals.trace ) {
				Jcvrmisc.print_trace( term2, "term2    ", System.currentTimeMillis() - t );
			}
		}
		{
			final long t = System.currentTimeMillis();
			dcset = Jcontain.sf_union( term1, term2 );
			if( Jglobals.trace ) {
				Jcvrmisc.print_trace( dcset, "union     ", System.currentTimeMillis() - t );
			}
		}
		final Jset_family dcsetbar[] = new Jset_family[1];// java holder
		final Jset_family temp[] = new Jset_family[1];// java holder
		{
			final long t = System.currentTimeMillis();
			temp[0] = PLA.D;// java
			Jcompl.simp_comp( Jcofactor.cube1list( dcset ), temp, dcsetbar );
			PLA.D = temp[0];// java
			if( Jglobals.trace ) {
				Jcvrmisc.print_trace( PLA.D, "simplify", System.currentTimeMillis() - t );
			}
		}
		{
			final long t = System.currentTimeMillis();
			newf = Jsharp.cv_intersect( PLA.F, dcsetbar[0] );
			if( Jglobals.trace ) {
				Jcvrmisc.print_trace( PLA.F, "separate  ", System.currentTimeMillis() - t );
			}
		}
		Jespresso.free_cover( PLA.F );
		PLA.F = newf;
		Jespresso.free_cover( Tplus[0] );
		Jespresso.free_cover( Tminus[0] );
		Jespresso.free_cover( Tplusbar[0] );
		Jespresso.free_cover( Tminusbar[0] );
		Jespresso.free_cover( dcsetbar[0] );

		/* remove any cubes dependent on the DONT_CARE variable */
		Jset.sf_active( PLA.F );

		final int[] data = PLA.F.data;// java
		for( int p = 0, last = p + PLA.F.count * PLA.F.wsize; p < last; p += PLA.F.wsize ) {
			if( ! Jespresso.is_in_set( data, p, var * 2 ) || ! Jespresso.is_in_set( data, p, var * 2 + 1 ) ) {
				Jespresso.RESET( data, p, Jespresso.ACTIVE );
			}
		}
		PLA.F = Jset.sf_inactive( PLA.F );

		/* resize the cube and delete the don't-care variable */
		Jcubestr.setdown_cube();
		for( int i = 2 * var + 2; i < cube.size; i++ ) {
			PLA.label[ i - 2 ] = PLA.label[ i ];
		}
		for( int i = var + 1; i < cube.num_vars; i++ ) {
			cube.part_size[ i - 1 ] = cube.part_size[ i ];
		}
		cube.num_binary_vars--;
		cube.num_vars--;
		Jcubestr.cube_setup();
		PLA.F = Jset.sf_delc( PLA.F, 2 * var, 2 * var + 1 );
		PLA.D = Jset.sf_delc( PLA.D, 2 * var, 2 * var + 1 );
	}

	static void map_output_symbolic(final JpPLA PLA) {
		final Jcube_struct cube = Jglobals.cube;// java

		/* Remove the DC-set from the ON-set (is this necessary ??) */
		if( PLA.D.count > 0 ) {
			Jset.sf_free( PLA.F );
			PLA.F = Jcompl.complement( Jcofactor.cube2list( PLA.D, PLA.R ) );
		}

		/* tot_size = width added for all symbolic variables */
		int tot_size = 0;
		for( Jsymbolic_t p1 = PLA.symbolic_output; p1 != null; p1 = p1.next ) {
			for( Jsymbolic_list_t p2 = p1.symbolic_list; p2 != null; p2 = p2.next ) {
				if( p2.pos < 0 || p2.pos >= cube.part_size[cube.output] ) {
					Jcvrmisc.fatal("symbolic-output index out of range");
					/*	    } else if( p2.variable != cube.output ) {
					fatal("symbolic-output label must be an output");*/
				}
			}
			tot_size += 1 << p1.symbolic_list_length;
		}

		/* adjust the indices to skip over new outputs */
		for( Jsymbolic_t p1 = PLA.symbolic_output; p1 != null; p1 = p1.next ) {
			for( Jsymbolic_list_t p2 = p1.symbolic_list; p2 != null; p2 = p2.next ) {
				p2.pos += tot_size;
			}
		}

		/* resize the cube structure -- add enough for the one-hot outputs */
		final int old_size = cube.size;
		cube.part_size[ cube.output ] += tot_size;
		Jcubestr.setdown_cube();
		Jcubestr.cube_setup();

		/* insert space in the output part for the one-hot output */
		int base = cube.first_part[ cube.output ];
		PLA.F = Jset.sf_addcol( PLA.F, base, tot_size );
		PLA.D = Jset.sf_addcol( PLA.D, base, tot_size );
		PLA.R = Jset.sf_addcol( PLA.R, base, tot_size );

		/* do the real work */
		final Jset_family newF[] = new Jset_family[1];// java holder
		final Jset_family newD[] = new Jset_family[1];// java holder
		for( Jsymbolic_t p1 = PLA.symbolic_output; p1 != null; p1 = p1.next ) {
			newF[0] = Jespresso.new_cover( 100 );
			newD[0] = Jespresso.new_cover( 100 );
			find_inputs( null, PLA, p1.symbolic_list, base, 0, newF, newD );
			/*
			*  Not sure what this means
			find_dc_inputs(PLA, p1.symbolic_list,
			base, 1 << p1.symbolic_list_length, &newF, &newD);
			*/
			Jespresso.free_cover( PLA.F );
			PLA.F = newF[0];
			/*
			*  retain OLD DC-set -- but we've lost the don't-care arc information
			*  (it defaults to branch to the zero state)
			free_cover(PLA.D);
			PLA.D = newD;
			*/
			Jespresso.free_cover( newD[0] );
			base += 1 << p1.symbolic_list_length;
		}

		/* delete the old outputs, and resize the cube */
		int[] compress = Jset.set_full( newF[0].sf_size );
		for( Jsymbolic_t p1 = PLA.symbolic_output; p1 != null; p1 = p1.next ) {
			for( Jsymbolic_list_t p2 = p1.symbolic_list; p2 != null; p2 = p2.next ) {
				final int bit = cube.first_part[ cube.output ] + p2.pos;
				Jespresso.set_remove( compress, bit );
			}
		}
		cube.part_size[cube.output] -= newF[0].sf_size - Jset.set_ord( compress );
		Jcubestr.setdown_cube();
		Jcubestr.cube_setup();
		PLA.F = Jset.sf_compress( PLA.F, compress );
		PLA.D = Jset.sf_compress( PLA.D, compress );
		if( cube.size != PLA.F.sf_size ) {
			Jcvrmisc.fatal("error");
		}

		/* Quick minimization */
		PLA.F = Jcontain.sf_contain( PLA.F );
		PLA.D = Jcontain.sf_contain( PLA.D );
		for( int i = 0; i < cube.num_vars; i++ ) {
			PLA.F = Jcontain.d1merge( PLA.F, i );
			PLA.D = Jcontain.d1merge( PLA.D, i );
		}
		PLA.F = Jcontain.sf_contain( PLA.F );
		PLA.D = Jcontain.sf_contain( PLA.D );

		Jespresso.free_cover( PLA.R );
		PLA.R = Jespresso.new_cover( 0 );

		symbolic_hack_labels( PLA, PLA.symbolic_output, compress, cube.size, old_size, tot_size );
		compress = null;
	}


	static void find_inputs(final Jset_family A, final JpPLA PLA, final Jsymbolic_list_t list, final int base, final int value, final Jset_family[] newF, final Jset_family[] newD) {
		final Jcube_struct cube = Jglobals.cube;// java

		/*
		*  A represents th 'input' values for which the outputs assume
		*  the integer value 'value
		*/
		if( list == null ) {
			/*
			*  Simulate these inputs against the on-set; then, insert into the
			*  new on-set a 1 in the proper position
			*/
			final Jset_family S = Jsharp.cv_intersect( A, PLA.F );

			final int[] data = S.data;// java
			for( int p = 0, last = p + S.count * S.wsize; p < last; p += S.wsize ) {
				Jespresso.set_insert( data, p, base + value );
			}
			newF[0] = Jset.sf_append( newF[0], S );

			/*
			*  'simulate' these inputs against the don't-care set
			S = cv_intersect(A, PLA.D);
			*newD = sf_append(*newD, S);
			*/

		} else {
			/* intersect and recur with the OFF-set */
			Jset_family S = Jcvrm.cof_output( PLA.R, cube.first_part[cube.output] + list.pos );
			if( A != null ) {
				final Jset_family S1 = Jsharp.cv_intersect( A, S );
				Jespresso.free_cover( S );
				S = S1;
			}
			find_inputs( S, PLA, list.next, base, value*2, newF, newD );
			Jespresso.free_cover( S );

			/* intersect and recur with the ON-set */
			S = Jcvrm.cof_output( PLA.F, cube.first_part[cube.output] + list.pos );
			if( A != null ) {
				final Jset_family S1 = Jsharp.cv_intersect( A, S );
				Jespresso.free_cover( S );
				S = S1;
			}
			find_inputs( S, PLA, list.next, base, value * 2 + 1, newF, newD );
			Jespresso.free_cover( S );
		}
	}


/* #if 0
	static void find_dc_inputs(final JpPLA PLA, final Jsymbolic_list_t[] list, final int base, final int maxval, Jset_matrix[] newF, final Jset_matrix[] newD) {
		pcover A, S, S1;
		symbolic_list_t *p2;
		final register pset p, last;
		register final int i;

		// painfully find the points for which the symbolic output is dc
		A = NIL(set_family_t);
		for( p2=list; p2!=NIL(symbolic_list_t); p2=p2.next ) {
			S = cof_output(PLA.D, cube.first_part[cube.output] + p2.pos);
			if( A == NIL(set_family_t) ) {
				A = S;
			} else {
				S1 = cv_intersect(A, S);
				free_cover(S);
				free_cover(A);
				A = S1;
			}
		}

		S = cv_intersect(A, PLA.F);
		*newF = sf_append(*newF, S);

		S = cv_intersect(A, PLA.D);
		foreach_set(S, last, p ) {
			for( i = base; i < base + maxval; i++ ) {
				set_insert(p, i);
			}
		}
		*newD = sf_append(*newD, S);
		free_cover(A);
	}
#endif */

	static void map_symbolic(final JpPLA PLA) {
		final Jcube_struct cube = Jglobals.cube;// java

		/* Verify legal values are in the symbolic lists */
		for( Jsymbolic_t p1 = PLA.symbolic; p1 != null; p1 = p1.next ) {
			for( Jsymbolic_list_t p2 = p1.symbolic_list; p2 != null; p2 = p2.next ) {
				if( p2.variable  < 0 || p2.variable >= cube.num_binary_vars ) {
					Jcvrmisc.fatal(".symbolic requires binary variables");
				}
			}
		}

		/*
		*  size_added = width added for all symbolic variables
		*  num_deleted_vars = # binary variables to be deleted
		*  num_added_vars = # new mv variables
		*  compress = a cube which will be used to compress the set families
		*/
		int size_added = 0;
		int num_added_vars = 0;
		for( Jsymbolic_t p1 = PLA.symbolic; p1 != null; p1 = p1.next ) {
			size_added += 1 << p1.symbolic_list_length;
			num_added_vars++;
		}
		int[] compress = Jset.set_full( PLA.F.sf_size + size_added );
		for( Jsymbolic_t p1 = PLA.symbolic; p1 != null; p1 = p1.next ) {
			for( Jsymbolic_list_t p2 = p1.symbolic_list; p2 != null; p2 = p2.next ) {
				Jespresso.set_remove( compress, p2.variable * 2 );
				Jespresso.set_remove( compress, p2.variable * 2 + 1 );
			}
		}
		final int num_deleted_vars = ((PLA.F.sf_size + size_added) - Jset.set_ord( compress )) >>> 1;

		/* compute the new cube constants */
		final int num_vars = cube.num_vars - num_deleted_vars + num_added_vars;
		final int num_binary_vars = cube.num_binary_vars - num_deleted_vars;
		final int new_size = cube.size - num_deleted_vars * 2 + size_added;
		final int[] new_part_size = new int[ num_vars ];
		new_part_size[num_vars - 1] = cube.part_size[cube.num_vars - 1];
		for( int var = cube.num_binary_vars; var < cube.num_vars - 1; var++ ) {
			new_part_size[var - num_deleted_vars] = cube.part_size[ var ];
		}

		/* re-size the covers, opening room for the new mv variables */
		int base = cube.first_part[cube.output];
		PLA.F = Jset.sf_addcol( PLA.F, base, size_added );
		PLA.D = Jset.sf_addcol( PLA.D, base, size_added );
		PLA.R = Jset.sf_addcol( PLA.R, base, size_added );

		/* compute the values for the new mv variables */
		int newvar = (cube.num_vars - 1) - num_deleted_vars;
		for( Jsymbolic_t p1 = PLA.symbolic; p1 != null; p1 = p1.next ) {
			PLA.F = map_symbolic_cover( PLA.F, p1.symbolic_list, base );
			PLA.D = map_symbolic_cover( PLA.D, p1.symbolic_list, base );
			PLA.R = map_symbolic_cover( PLA.R, p1.symbolic_list, base );
			base += 1 << p1.symbolic_list_length;
			new_part_size[newvar++] = 1 << p1.symbolic_list_length;
		}

		/* delete the binary variables which disappear */
		PLA.F = Jset.sf_compress( PLA.F, compress );
		PLA.D = Jset.sf_compress( PLA.D, compress );
		PLA.R = Jset.sf_compress( PLA.R, compress );

		symbolic_hack_labels( PLA, PLA.symbolic, compress, new_size, cube.size, size_added );
		Jcubestr.setdown_cube();
		cube.part_size = null;
		cube.num_vars = num_vars;
		cube.num_binary_vars = num_binary_vars;
		cube.part_size = new_part_size;
		Jcubestr.cube_setup();
		compress = null;
	}

	static Jset_family map_symbolic_cover(final Jset_family T, final Jsymbolic_list_t list, final int base) {
		final int[] data = T.data;// java
		for( int p = 0, last = p + T.count * T.wsize; p < last; p += T.wsize ) {
			form_bitvector( data, p, base, 0, list );
		}
		return T;
	}

	/**
	 *
	 * @param p old cube, looking at binary variables
	 * @param base where in mv cube the new variable starts
	 * @param value current value for this recursion
	 * @param list current place in the symbolic list
	 */
	static void form_bitvector(final int[] p, final int off, final int base, final int value, final Jsymbolic_list_t list) {
		if( list == null ) {
			Jespresso.set_insert( p, off, base + value );
		} else {
			switch( Jespresso.GETINPUT( p, off, list.variable ) ) {
			case Jespresso.ZERO:
				form_bitvector( p, off, base, value * 2, list.next );
				break;
			case Jespresso.ONE:
				form_bitvector( p, off, base, value * 2 + 1, list.next );
				break;
			case Jespresso.TWO:
				form_bitvector( p, off, base, value * 2, list.next );
				form_bitvector( p, off, base, value * 2 + 1, list.next );
				break;
			default:
				Jcvrmisc.fatal("bad cube in form_bitvector");
			}
		}
	}


	@SuppressWarnings("boxing")
	static void symbolic_hack_labels(final JpPLA PLA, final Jsymbolic_t list, final int[] compress, final int new_size, final int old_size, final int size_added) {
		final Jcube_struct cube = Jglobals.cube;// java
		String[] oldlabel;

		/* hack with the labels */
		if( (oldlabel = PLA.label) == null ) {
			return;
		}
		PLA.label = new String[ new_size ];
		for( int i = 0; i < new_size; i++ ) {
			PLA.label[i] = null;
		}

		/* copy the binary variable labels and unchanged mv variable labels */
		int base = 0;
		for( int i = 0; i < cube.first_part[cube.output]; i++ ) {
			if( Jespresso.is_in_set( compress, i ) ) {
				PLA.label[ base++ ] = oldlabel[ i ];
			} else {
				oldlabel[ i ] = null;
			}
		}

		/* add the user-defined labels for the symbolic outputs */
		for( Jsymbolic_t p1 = list; p1 != null; p1 = p1.next ) {
			Jsymbolic_label_t p3 = p1.symbolic_label;
			for( int i = 0; i < (1 << p1.symbolic_list_length); i++ ) {
				if( p3 == null ) {
					PLA.label[ base + i ] = String.format( "X%d", i );
				} else {
					PLA.label[ base + i ] = p3.label;
					p3 = p3.next;
				}
			}
			base += 1 << p1.symbolic_list_length;
		}

		/* copy the labels for the binary outputs which remain */
		for( int i = cube.first_part[ cube.output ]; i < old_size; i++ ) {
			if( Jespresso.is_in_set( compress, i + size_added ) ) {
				PLA.label[ base++ ] = oldlabel[ i ];
			} else {
				oldlabel[ i ] = null;
			}
		}
		oldlabel = null;
	}

	private static Jset_family fsm_simplify(Jset_family F) {
		final Jset_family D = Jespresso.new_cover( 0 );
		final Jset_family R = Jcompl.complement( Jcofactor.cube1list( F ) );
		F = Jespresso.espresso( F, D, R );
		Jespresso.free_cover( D );
		Jespresso.free_cover( R );
		return F;
	}


	@SuppressWarnings("boxing")
	static void disassemble_fsm(final JpPLA PLA, final boolean verbose_mode) {
		final Jcube_struct cube = Jglobals.cube;// java

		/* We make the DISGUSTING assumption that the first 'n' outputs have
		*  been created by .symbolic-output, and represent a one-hot encoding
		* of the next state.  'n' is the size of the second-to-last multiple-
		* valued variable (i.e., before the outputs
		*/

		if( cube.num_vars - cube.num_binary_vars != 2 ) {
			System.err.printf("use .symbolic and .symbolic-output to specify\n");
			System.err.printf("the present state and next state field information\n");
			Jcvrmisc.fatal("disassemble_pla: need two multiple-valued variables\n");
		}

		final int nin = cube.num_binary_vars;
		final int nstates = cube.part_size[cube.num_binary_vars];
		final int nout = cube.part_size[cube.num_vars - 1];
		if( nout < nstates ) {
			System.err.printf("use .symbolic and .symbolic-output to specify\n");
			System.err.printf("the present state and next state field information\n");
			Jcvrmisc.fatal("disassemble_pla: # outputs < # states\n");
		}


		final int present_state = cube.first_part[ cube.num_binary_vars ];
		int[] present_state_mask = Jespresso.new_cube();
		for( int i = 0; i < nstates; i++ ) {
			Jespresso.set_insert( present_state_mask, i + present_state );
		}

		final int next_state = cube.first_part[cube.num_binary_vars+1];
		int[] next_state_mask = Jespresso.new_cube();
		for( int i = 0; i < nstates; i++ ) {
			Jespresso.set_insert( next_state_mask, i + next_state );
		}

		int[] state_mask = Jespresso.new_cube();
		Jset.set_or( state_mask, next_state_mask, present_state_mask );

		Jset_family F = Jespresso.new_cover( 10 );

		/*
		*  check for arcs which go from ANY state to state #i
		*/
		for( int i = 0; i < nstates; i++ ) {
			Jset_family tF = Jespresso.new_cover( 10 );

			int[] data = PLA.F.data;// java
			for( int p = 0, last = p + PLA.F.count * PLA.F.wsize; p < last; p += PLA.F.wsize ) {
				if( Jset.setp_implies( present_state_mask, data, p ) ) { /* from any state ! */
					if( Jespresso.is_in_set( data, p, next_state + i ) ) {
						tF = Jset.sf_addset( tF, data, p );
					}
				}
			}
			final int before = tF.count;
			if( before > 0 ) {
				tF = fsm_simplify( tF );
				/* don't allow the next state to disappear ... */
				data = tF.data;// java
				for( int p = 0, last = p + tF.count * tF.wsize; p < last; p += tF.wsize ) {
					Jespresso.set_insert( data, p, next_state + i );
				}
				final int after = tF.count;
				F = Jset.sf_append( F, tF );
				if( verbose_mode ) {
					System.out.printf("# state EVERY to %d, before=%d after=%d\n",
							i, before, after);
				}
			}
		}

		/*
		*  some 'arcs' may NOT have a next state -- handle these
		*  we must unravel the present state part
		*/
		Jset_family go_nowhere = Jespresso.new_cover( 10 );
		int[] data = PLA.F.data;// java
		for( int p = 0, last = p + PLA.F.count * PLA.F.wsize; p < last; p += PLA.F.wsize ) {
			if( Jset.setp_disjoint( data, p, next_state_mask ) ) { /* no next state !! */
				go_nowhere = Jset.sf_addset( go_nowhere, data, p );
			}
		}
		int before = go_nowhere.count;
		go_nowhere = Jcvrm.unravel_range( go_nowhere, cube.num_binary_vars, cube.num_binary_vars );
		int after = go_nowhere.count;
		F = Jset.sf_append( F, go_nowhere );
		if( verbose_mode ) {
			System.out.printf("# state ANY to NOWHERE, before=%d after=%d\n", before, after);
		}

		/*
		*  minimize cover for all arcs from state #i to state #j
		*/
		for( int i = 0; i < nstates; i++ ) {
			for( int j = 0; j < nstates; j++ ) {
				Jset_family tF = Jespresso.new_cover( 10 );
				data = PLA.F.data;// java
				for( int p = 0, last = p + PLA.F.count * PLA.F.wsize; p < last; p += PLA.F.wsize ) {
					/* not EVERY state */
					if( ! Jset.setp_implies( present_state_mask, data, p ) ) {
						if( Jespresso.is_in_set( data, p, present_state + i ) ) {
							if( Jespresso.is_in_set( data, p, next_state + j ) ) {
								int[] p1 = Jset.set_save( data, p );
								Jset.set_diff( p1, p1, state_mask );
								Jespresso.set_insert( p1, present_state + i );
								Jespresso.set_insert( p1, next_state + j );
								tF = Jset.sf_addset( tF, p1 );
								p1 = null;
							}
						}
					}
				}
				before = tF.count;
				if( before > 0 ) {
					tF = fsm_simplify( tF );
					/* don't allow the next state to disappear ... */
					data = tF.data;// java
					for( int p = 0, last = p + tF.count * tF.wsize; p < last; p += tF.wsize ) {
						Jespresso.set_insert( data, p, next_state + j );
					}
					after = tF.count;
					F = Jset.sf_append( F, tF );
					if( verbose_mode ) {
						System.out.printf("# state %d to %d, before=%d after=%d\n",
								i, j, before, after);
					}
				}
			}
		}

		state_mask = null;
		present_state_mask = null;
		next_state_mask = null;

		Jespresso.free_cover( PLA.F );
		PLA.F = F;
		Jespresso.free_cover( PLA.D );
		PLA.D = Jespresso.new_cover( 0 );

		Jcubestr.setdown_cube();
		cube.part_size = null;
		cube.num_binary_vars = nin;
		cube.num_vars = nin + 3;
		cube.part_size = new int[ cube.num_vars ];
		cube.part_size[ cube.num_binary_vars ] = nstates;
		cube.part_size[ cube.num_binary_vars + 1 ] = nstates;
		cube.part_size[ cube.num_binary_vars + 2 ] = nout - nstates;
		Jcubestr.cube_setup();

		data = PLA.F.data;// java
		for( int p = 0, last = p + PLA.F.count * PLA.F.wsize; p < last; p += PLA.F.wsize ) {
			Jcvrout.kiss_print_cube( System.out, PLA, data, p, "~1" );
		}
	}
}