package espresso;
final class Jindep {

// #if 0
	/**
	 *  verify that all rows in 'indep' are actually independent !
	 */
	/* private static int verify_indep_set(Jsm_matrix A, Jsm_row indep) {
		for( Jsm_element p = indep.first_col; p != null; p = p.next_col ) {
			Jsm_row prow = Jsparse.sm_get_row( A, p.col_num );
			for( Jsm_element p1 = p.next_col; p1 != null; p1 = p1.next_col) {
				Jsm_row prow1 = Jsparse.sm_get_row( A, p1.col_num );
				if( Jrows.sm_row_intersects( prow, prow1 ) ) {
					return 0;
				}
			}
		}
		return 1;
	} */
// #endif

	static Jsolution sm_maximal_independent_set(final Jsm_matrix A, final int[] weight) {
		final Jsolution indep = Jsolution.solution_alloc();
		final Jsm_matrix B = build_intersection_matrix( A );

		while( B.nrows > 0 ) {
			/*  Find the row which is disjoint from a maximum number of rows */
			Jsm_row best_row = B.first_row;
			for( Jsm_row prow = B.first_row.next_row; prow != null; prow = prow.next_row ) {
				if( prow.length < best_row.length ) {
					best_row = prow;
				}
			}

			/* Find which element in this row has least weight */
			int least_weight;
			if( weight == null ) {
				least_weight = 1;
			} else {
				final Jsm_row prow = Jsparse.sm_get_row( A, best_row.row_num );
				least_weight = weight[ prow.first_col.col_num ];
				for( Jsm_element p = prow.first_col.next_col; p != null; p = p.next_col ) {
					if( weight[p.col_num] < least_weight ) {
						least_weight = weight[ p.col_num ];
					}
				}
			}
			indep.cost += least_weight;
			Jrows.sm_row_insert( indep.row, best_row.row_num );

			/*  Discard the rows which intersect this row */
			final Jsm_row save = Jrows.sm_row_dup( best_row );
			for( Jsm_element p = save.first_col; p != null; p = p.next_col ) {
				Jmatrix.sm_delrow( B, p.col_num );
				Jmatrix.sm_delcol( B, p.col_num );
			}
			Jrows.sm_row_free( save );
		}

		Jmatrix.sm_free( B );

		/*
		if (! verify_indep_set(A, indep.row)) {
		fail("sm_maximal_independent_set: row set is not independent");
		}
		*/
		return indep;
	}

	private static Jsm_matrix build_intersection_matrix(final Jsm_matrix A) {
		/* Build row-intersection matrix */
		final Jsm_matrix B = Jmatrix.sm_alloc();
		for( Jsm_row prow = A.first_row; prow != null; prow = prow.next_row) {

			/* Clear flags on all rows we can reach from row 'prow' */
			for( Jsm_element p = prow.first_col; p != null; p = p.next_col ) {
				final Jsm_col pcol = Jsparse.sm_get_col( A, p.col_num );
				for( Jsm_element p1 = pcol.first_row; p1 != null; p1 = p1.next_row ) {
					final Jsm_row prow1 = Jsparse.sm_get_row( A, p1.row_num );
					prow1.flag = false;
				}
			}

			/* Now record which rows can be reached */
			for( Jsm_element p = prow.first_col; p != null; p = p.next_col ) {
				final Jsm_col pcol = Jsparse.sm_get_col( A, p.col_num );
				for( Jsm_element p1 = pcol.first_row; p1 != null; p1 = p1.next_row ) {
					final Jsm_row prow1 = Jsparse.sm_get_row( A, p1.row_num );
					if( ! prow1.flag ) {
						prow1.flag = true;
						Jmatrix.sm_insert( B, prow.row_num, prow1.row_num );
					}
				}
			}
		}

		return B;
	}
}