package espresso;
final class Jmap {

	private static int[] Gcube_base;
	private static int Gcube;

	private static int[] Gminterm;

	private static int[] minterms(final Jset_family T) {
		final Jcube_struct cube = Jglobals.cube;// java

		int size = 1;
		for( int var = 0; var < cube.num_vars; var++ ) {
			size *= cube.part_size[ var ];
		}
		Gminterm = Jset.set_new( size );

		final int[] data = T.data;// java
		Gcube_base = data;
		Gcube = 0;
		for( final int last = Gcube + T.count * T.wsize; Gcube < last; Gcube += T.wsize ) {
			explode( cube.num_vars - 1, 0 );
		}

		return Gminterm;
	}

	private static void explode(final int var, int z) {
		final Jcube_struct cube = Jglobals.cube;// java
		int i;
		final int last = cube.last_part[ var ];
		for( i = cube.first_part[ var ], z *= cube.part_size[ var ]; i <= last; i++, z++ ) {
			if( Jespresso.is_in_set( Gcube_base, Gcube, i ) ) {
				if( var == 0 ) {
					Jespresso.set_insert( Gminterm, z );
				} else {
					explode( var - 1, z );
				}
			}
		}
	}

	private static final int mapindex[/* 16 */][/* 16 */] = {
		{0,  1,  3,  2,   16, 17, 19, 18,      80, 81, 83, 82,   64, 65, 67, 66},
		{4,  5,  7,  6,   20, 21, 23, 22,      84, 85, 87, 86,   68, 69, 71, 70},
		{12, 13, 15, 14,   28, 29, 31, 30,      92, 93, 95, 94,   76, 77, 79, 78},
		{8,  9, 11, 10,   24, 25, 27, 26,      88, 89, 91, 90,   72, 73, 75, 74},

		{32, 33, 35, 34,   48, 49, 51, 50,     112,113,115,114,   96, 97, 99, 98},
		{36, 37, 39, 38,   52, 53, 55, 54,     116,117,119,118,  100,101,103,102},
		{44, 45, 47, 46,   60, 61, 63, 62,     124,125,127,126,  108,109,111,110},
		{40, 41, 43, 42,   56, 57, 59, 58,     120,121,123,122,  104,105,107,106},

		{160,161,163,162,  176,177,179,178,     240,241,243,242,  224,225,227,226},
		{164,165,167,166,  180,181,183,182,     244,245,247,246,  228,229,231,230},
		{172,173,175,174,  188,189,191,190,     252,253,255,254,  236,237,239,238},
		{168,169,171,170,  184,185,187,186,     248,249,251,250,  232,233,235,234},

		{128,129,131,130,  144,145,147,146,     208,209,211,210,  192,193,195,194},
		{132,133,135,134,  148,149,151,150,     212,213,215,214,  196,197,199,198},
		{140,141,143,142,  156,157,159,158,     220,221,223,222,  204,205,207,206},
		{136,137,139,138,  152,153,155,154,     216,217,219,218,  200,201,203,202}
	};

	@SuppressWarnings("boxing")
	static void map(final Jset_family T) {
		final Jcube_struct cube = Jglobals.cube;// java
		int[] m = minterms( T );
		final int largest_input_ind = (1 << cube.num_binary_vars);
		final int numout = cube.part_size[ cube.num_vars - 1 ];

		for( int outnum = 0; outnum < numout; outnum++ ) {
			final int output_offset = outnum * largest_input_ind;
			System.out.printf("\n\nOutput space # %d\n", outnum );
			for( int l = 0; l <= Math.max( cube.num_binary_vars - 8, 0 ); l++ ) {
				final int other_input_offset = l * 256;
				for( int k = 0; k < 16; k++ ) {
					boolean some_output = false;
					for( int j = 0; j < 16; j++ ) {
						final int ind = mapindex[ k ][ j ] + other_input_offset;
						if( ind < largest_input_ind ) {
							final char c = Jespresso.is_in_set( m, ind + output_offset ) ? '1' : '.';
							System.out.print( c );
							some_output = true;
						}
						if( (j + 1) % 4 == 0 ) {
							System.out.print(' ');
						}
						if( (j + 1) % 8 == 0 ) {
							System.out.printf("  ");
						}
					}
					if( some_output ) {
						System.out.print('\n');
					}
					if( (k + 1) % 4 == 0 ) {
						if( k != 15 && mapindex[ k + 1 ][ 0 ] >= largest_input_ind ) {
							break;
						}
						System.out.print('\n');
					}
					if( (k + 1) % 8 == 0 ) {
						System.out.print('\n');
					}
				}
			}
		}
		m = null;
	}
}