package espresso;

final class Jpart {

	private static void copy_row(final Jsm_matrix A, final Jsm_row prow) {
		for( Jsm_element p = prow.first_col; p != null; p = p.next_col ) {
			Jmatrix.sm_insert( A, p.row_num, p.col_num );
		}
	}

	private static boolean visit_row(final Jsm_matrix A, final Jsm_row prow, final int[] rows_visited, final int[] cols_visited) {
		if( ! prow.flag ) {
			prow.flag = true;
			rows_visited[ 0 ]++;
			if( rows_visited[ 0 ] == A.nrows ) {
				return true;
			}
			for( Jsm_element p = prow.first_col; p != null; p = p.next_col ) {
				final Jsm_col pcol = Jsparse.sm_get_col( A, p.col_num );
				if( ! pcol.flag ) {
					if( visit_col( A, pcol, rows_visited, cols_visited ) ) {
						return true;
					}
				}
			}
		}
		return false;
	}

	private static boolean visit_col(final Jsm_matrix A, final Jsm_col pcol, final int[] rows_visited, final int[] cols_visited) {
		if( ! pcol.flag ) {
			pcol.flag = true;
			cols_visited[0]++;
			if( cols_visited[0] == A.ncols ) {
				return true;
			}
			for( Jsm_element p = pcol.first_row; p != null; p = p.next_row ) {
				final Jsm_row prow = Jsparse.sm_get_row( A, p.row_num );
				if( ! prow.flag ) {
					if( visit_row( A, prow, rows_visited, cols_visited ) ) {
						return true;
					}
				}
			}
		}
		return false;
	}

	static boolean sm_block_partition(final Jsm_matrix A, final Jsm_matrix[] L, final Jsm_matrix[] R) {
		/* Avoid the trivial case */
		if( A.nrows == 0 ) {
			return false;
		}

		/* Reset the visited flags for each row and column */
		for( Jsm_row prow = A.first_row; prow != null; prow = prow.next_row ) {
			prow.flag = false;
		}
		for( Jsm_col pcol = A.first_col; pcol != null; pcol = pcol.next_col ) {
			pcol.flag = false;
		}

		final int cols_visited[] = new int[] { 0 };// java
		final int rows_visited[] = new int[] { 0 };// java
		if( visit_row( A, A.first_row, rows_visited, cols_visited ) ) {
			/* we found all of the rows */
			return false;
		}// else {
			L[0] = Jmatrix.sm_alloc();
			R[0] = Jmatrix.sm_alloc();
			for( Jsm_row prow = A.first_row; prow != null; prow = prow.next_row ) {
				if( prow.flag ) {
					copy_row( L[0], prow );
				} else {
					copy_row( R[0], prow );
				}
			}
			return true;
		//}
	}
}