package espresso;

/**
 * Module: signature.c
 * Purpose: The main signature algorithm
 * Routines;
 * pcover signature():
 *	Entry point for the signature cubes algorithm.
 * pcover generate_primes():
 *	Generates the set of primes corresponding to
 *	the Essential Signature Cubes
 */
final class Jsignature {
	/* java: never used signature.h
	private static final int ODD_MASK  = (Jespresso.BPI == 16) ? 0xaaaa : 0xaaaaaaaa;
	private static final int EVEN_MASK = (Jespresso.BPI == 16) ? 0x5555 : 0x55555555;

	private static final int POSITIVE = 1;
	private static final int NEGATIVE = 0;

	private static final int PRESENT  = 1;
	private static final int ABSENT   = 0;

	private static final int RAISED   = 2;
	// end signature.h */

	/** yuk */
	private static long start_time;

	static Jset_family signature(final Jset_family F1, final Jset_family D1, final Jset_family R1) {
		final Jset_family ESC;
		Jset_family ESSet;
		final Jset_family ESSENTIAL;

		/* make scratch copy */
		final Jset_family[] F = new Jset_family[1];// java holder
		final Jset_family[] D = new Jset_family[1];// java holder
		F[0] = Jset.sf_save( F1 );
		D[0] = Jset.sf_save( D1 );
		Jset_family R = Jset.sf_save( R1 );

		/* unwrap offset */
		R = Jcvrm.unravel( R, Jglobals.cube.num_binary_vars );
		R = Jcontain.sf_contain( R );

		// signal( SIGXCPU, cleanup );// TODO find an analog in java
		start_time = System.currentTimeMillis();

		/* Initial expand and irredundant */
		final int[] data = F[0].data;// java
		for( int p = 0, last = p + F[0].count * F[0].wsize; p < last; p += F[0].wsize ) {
			Jespresso.RESET( data, p, Jespresso.PRIME );
		}

		{
			final long t = System.currentTimeMillis();
			F[0] = Jexpand.expand( F[0], R, false );
			Jutil_signature.s_totals( t, Jespresso.ESSEN_TIME );
		}
		{
			final long t = System.currentTimeMillis();
			F[0] = Jirred.irredundant( F[0], D[0] );
			Jutil_signature.s_totals( t, Jespresso.ESSEN_TIME );
		}
		{
			final long t = System.currentTimeMillis();
			ESSENTIAL = Jessen.essential( F, D );
			Jutil_signature.s_totals( t, Jespresso.ESSEN_TIME );
		}
		{
			final long t = System.currentTimeMillis();
			ESC = Jcanonical.find_canonical_cover( F[0], D[0], R );
			Jutil_signature.s_totals( t, Jespresso.FCC_TIME );
		}
		/**************************************************
		printf("ESCubes %d\n", ESC.count + ESSENTIAL.count);
		fflush(stdout);
		**************************************************/

		{
			final long t = System.currentTimeMillis();
			ESSet = Jsignature.generate_primes( ESC, R );
			Jutil_signature.s_totals( t, Jespresso.PRIMES_TIME );
		}
		/**************************************************
		printf("ESSet %d\n",ESSet.count + ESSENTIAL.count);
		fflush(stdout);
		**************************************************/

		{
			final long t = System.currentTimeMillis();
			F[0] = Jsignature_exact.signature_minimize_exact( ESC, ESSet );
			Jutil_signature.s_totals( t, Jespresso.MINCOV_TIME );
		}
		Jset.sf_append( F[0], ESSENTIAL );
		/**************************************************
		printf("Exact_Minimum %d\n",F.count);
		print_cover(F,"Exact Minimum");
		**************************************************/

		if( ! Jglobals.skip_make_sparse && R != null ) {
			F[0] = Jsparse.make_sparse( F[0], D1, R );
		}

		Jespresso.free_cover( D[0] );
		Jespresso.free_cover( R );
		Jespresso.free_cover( ESC );
		Jespresso.free_cover( ESSet );
		return F[0];
	}

	static Jset_family generate_primes(final Jset_family F, final Jset_family R) {
		final Jcube_struct cube = Jglobals.cube;// java
		int[] out_part_r = Jespresso.new_cube();
		// int[] odd = Jespresso.new_cube();// java: never used
		// int[] even = Jespresso.new_cube();// java: never used

		int count = 0;
		Jset_family PRIMES = Jespresso.new_cover( F.count );

		final int[] data = F.data;// java
		for( int c = 0, lastc = c + F.count * F.wsize; c < lastc; c += F.wsize ) {
			Jset_family BB = Jespresso.new_cover( R.count );
			BB.count = R.count;
			/* BB = get_blocking_matrix(R,c); */
			final int[] r_data = R.data;// java
			for( int r = 0, i = 0; i < R.count; r += R.wsize, i++ ) {
				final int[] base = BB.data;// java
				final int b = BB.wsize * i;// GETSET( BB, i );
				int last;
				if( (last = cube.inword) != -1 ) {
					/* Check the partial word of binary variables */
					int x = r_data[ r + last ] & data[ c + last ];
					x = ~(x | x >>> 1) & cube.inmask;
					base[ b + last ] = r_data[ r + last ] & (x | x << 1);
					/* Check the full words of binary variables */
					for( int w = 1; w < last; w++ ) {
						x = r_data[ r + w ] & data[ c + w ];
						x = ~(x | x >>> 1) & Jespresso.DISJOINT;
						base[ b + w ] = r_data[ r + w ] & (x | x << 1);
					}
				}
				Jespresso.PUTLOOP( base, b, Jespresso.LOOP( r_data, r ) );
				Jset.set_and( base, b, base, b, cube.binary_mask );
				Jset.set_and( out_part_r, cube.mv_mask, r_data, r );
				if( ! Jset.setp_implies( out_part_r, data, c ) ) {
					Jset.set_or( base, b, base, b, out_part_r );
				}
			}
			BB = Junate.unate_compl( BB );
			if( BB != null ) {
				final int[] bb_data = BB.data;// java
				for( int b = 0, lastb = b + BB.count * BB.wsize; b < lastb; b += BB.wsize ) {
					Jsigma.set_not( bb_data, b );
				}
				Jset.sf_append( PRIMES, BB );
			}
			count++;
			if( count % 100 == 0 ) {
				PRIMES = Jcontain.sf_contain( PRIMES );
			}
		}
		PRIMES = Jcontain.sf_contain( PRIMES );
		out_part_r = null;
		// odd = null;
		// even = null;
		return PRIMES;
	}

	static void cleanup() {
		Jutil_signature.s_runtime( System.currentTimeMillis() - start_time );
		System.out.printf("CPU Limit Exceeded\n");
		Jmain.closeStreams();
		System.exit( 1 );
	}
}