package espresso;

/** solution_struct */
final class Jsolution {

	Jsm_row row;
	int cost;

	static Jsolution solution_alloc() {
		final Jsolution sol = new Jsolution();
		sol.cost = 0;
		sol.row = Jrows.sm_row_alloc();
		return sol;
	}

	static void solution_free(Jsolution sol) {
		Jrows.sm_row_free( sol.row );
		sol = null;
	}

	static Jsolution solution_dup(final Jsolution sol) {
		final Jsolution new_sol = new Jsolution();
		new_sol.cost = sol.cost;
		new_sol.row = Jrows.sm_row_dup( sol.row );
		return new_sol;
	}

	static void solution_add(final Jsolution sol, final int[] weight, final int col) {
		Jrows.sm_row_insert( sol.row, col );
		sol.cost += Jmincov.WEIGHT( weight, col );
	}

	static void solution_accept(final Jsolution sol, final Jsm_matrix A, final int[] weight, final int col) {
		solution_add( sol, weight, col );

		/* delete rows covered by this column */
		final Jsm_col pcol = Jsparse.sm_get_col( A, col );
		for( Jsm_element pnext, p = pcol.first_row; p != null; p = pnext ) {
			pnext = p.next_row;		/* grab it before it disappears */
			Jmatrix.sm_delrow( A, p.row_num );
		}
	}

	/** ARGSUSED */
	static void solution_reject(final Jsolution sol, final Jsm_matrix A, final int[] weight, final int col) {
		Jmatrix.sm_delcol( A, col );
	}

	static Jsolution solution_choose_best(final Jsolution best1, final Jsolution best2) {
		if( best1 != null ) {
			if( best2 != null ) {
				if( best1.cost <= best2.cost ) {
					solution_free( best2 );
					return best1;
				}// else {
					solution_free( best1 );
					return best2;
				//}
			}// else {
				return best1;
			//}
		}// else {
			if( best2 != null ) {
				return best2;
			}// else {
				return null;
			//}
		//}
	}
}